<?php

namespace FiloBlu\GuestWishlist\Controller\Plugin;

use Magento\Framework\Controller\ResultFactory;
use Magento\Catalog\Api\ProductRepositoryInterface;


class Add {

    public function __construct(
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Framework\Message\ManagerInterface $messagesManager,
        \Magento\Framework\App\RequestInterface $request,
        \Magento\Framework\Controller\Result\Redirect $resultRedirect,
        \Magento\Framework\Data\Form\FormKey\Validator $formKeyValidator,
        ProductRepositoryInterface $productRepository
    ) {
        $this->resultJsonFactory = $resultJsonFactory;
        $this->messageManager = $messagesManager;
        $this->request = $request;
        $this->resultFactory = $resultRedirect;
        $this->formKeyValidator = $formKeyValidator;
        $this->productRepository = $productRepository;
    }

    public function afterExecute($object, $resultPage) {

        if(!$this->request->isXmlHttpRequest()) {
            return $resultPage;
        }

        $requestParams = $this->request->getParams();

        $resultJson = $this->resultJsonFactory->create();

        $productId = isset($requestParams['product']) ? (int)$requestParams['product'] : null;

        try {
            $product = $this->productRepository->getById($productId);
        } catch (NoSuchEntityException $e) {
            $product = null;
        }

        if (!$productId) {
            $resultRedirect->setPath('*/');
            return $resultRedirect;
        }

        return $resultJson->setData([
                'product_sku' => $product->getSku()
        ]);

    }

}
